<?php
/**
*
* permissions [English]
*
* @package language
* @version $Id: permissions.php,v 1.57 2011/05/05 17:05:53 henryhou Exp $
* @copyright (c) 2008 Stratus Technologies
* @license Emergent Network Solutions
*
*/

/**
* DO NOT CHANGE
*/
if (empty($lang) || !is_array($lang))
{
	$lang = array();
}

/**
 * DEVELOPERS PLEASE NOTE
 *
 * All language files should use UTF-8 as their encoding and the files must not contain a BOM.
 *
 * Placeholders can now contain order information, e.g. instead of
 * 'Page %s of %s' you can (and should) write 'Page %1$s of %2$s', this allows
 * translators to re-order the output of data while ensuring it remains correct
 *
 * You do not need this where single placeholders are used, e.g. 'Message %d' is fine
 * equally where a string contains only two placeholders which are used to wrap text
 * in a url you again do not need to specify an order e.g., 'Click %sHERE%s' is fine
 *
 * All strings should be single quotations. If you require the use of a single quote within a string,
 * use an apostrophe or escape the quotation using a backslash.
 * Valid examples: can’t, it’s, can\'t, it\'s
 * Some characters you may want to copy&paste:
 * ’ » “ …
 */

// Define categories and permission types
$lang = array_merge($lang, array(
	'permission_cat'	=> array(
		'administration'			=> 'Administration',
		'agent_admin'				=> 'Retail Business Admin',
		'business_admin'			=> 'Business Admin',
		'charges'					=> 'Charges',
		'enterprise_admin'			=> 'Enterprise Admin',
		'sip_trunk_admin'			=> 'SIP Trunk Admin',
		'feature_administration'	=> 'Feature Administration',
		'device_administration'		=> 'Device Administration' ,
		'invoicing'					=> 'Reports',
		'permissions'				=> 'Permissions',
		'rates'						=> 'Rates',
		'subscriber'				=> 'Subscriber',
		'templates'					=> 'Templates',
		'dids'						=> 'DIDs',
		'dnis'						=> 'DNIS Admin',
		'retailcard_admin'			=> 'Calling Card Admin',
		'card_subscriber'           => 'Card Subscribers',
		'ani_admin'					=> 'ANI Admin',
		'ani_subscriber'			=> 'ANI Subscriber',
		'reports'					=> 'Calling Card Reports',
		'ani_reports'				=> 'ANI Reports',
		'credit_mgmt'				=> 'Credit Card Management',
		'enterprise_reports'		=> 'Enterprise Reports',
		'retail_reports'			=> 'Retail Reports',
		'call_shop'					=> 'Call Shop',
	),

	// With defining 'global' here we are able to specify what is printed out if the permission is within the global scope.
	'permission_type'	=> array(
		'o_'			=> 'Owner permissions',
		'r_'			=> 'Reseller permissions',
		'u_'			=> 'User permissions',
	),
));

$lang = array_merge($lang, array(
	// Owner rates
	'o_rates'						=> array('lang' => 'Can view rates',					'cat' => 'rates'), // 2
	'o_dial_code_maintenance_read'	=> array('lang' => 'Can view dial code maintenance',	'cat' => 'rates'),
	'o_dial_code_maintenance'		=> array('lang' => 'Can manage dial code maintenance',	'cat' => 'rates'), // 9 
	'o_rate_maintenance_read'		=> array('lang'	=> 'Can view rate maintenance',			'cat' => 'rates'),
	'o_rate_maintenance'			=> array('lang'	=> 'Can manage rate maintenance',		'cat' => 'rates'), // 11
	'o_misc_features_read'			=> array('lang'	=> 'Can view misc features',			'cat' => 'rates'),
	'o_misc_features'				=> array('lang'	=> 'Can manage misc features',			'cat' => 'rates'), // 87
	'o_authorize_rate_change_read'	=> array('lang'	=> 'Can view authorize rate changes',	'cat' => 'rates'),
	'o_authorize_rate_change'		=> array('lang'	=> 'Can manage authorize rate changes',	'cat' => 'rates'), // 10
	'o_define_rate_offerings_read'	=> array('lang'	=> 'Can view rate offerings',			'cat' => 'rates'),
	'o_define_rate_offerings'		=> array('lang'	=> 'Can manage rate offerings',	    	'cat' => 'rates'), // 12

	// Owner Charges
	'o_charges'				=> array('lang' => 'Can view charges',			'cat' => 'charges'), // 4
	'o_tax_plan_read'		=> array('lang'	=> 'Can view tax plans',		'cat' => 'charges'), // 15
	'o_tax_plan'			=> array('lang'	=> 'Can manage tax plans',		'cat' => 'charges'),

	// Owner Busines Admin
	'o_business_admin'				=> array('lang' => 'Can view Business Administration',	'cat' => 'business_admin'), // 3
	'o_reseller_maintenance_read'	=> array('lang' => 'Can view reseller maintenance', 	'cat' => 'business_admin'), // 13
	'o_reseller_maintenance'		=> array('lang' => 'Can manage reseller maintenance', 	'cat' => 'business_admin'), // 13
	'o_reseller_summary'			=> array('lang' => 'Can view reseller summary', 		'cat' => 'business_admin'), // 14
	
	// Owner View Invoices
	'o_owner_invoicing'				=> array('lang' => 'Can view invoicing', 		'cat' => 'invoicing'), // 5
	'o_view_invoices_read'			=> array('lang' => 'Can view reseller invoices','cat' => 'invoicing'), // 18
	'o_rated_call_record'			=> array('lang' => 'Can view rated call record report', 		'cat' => 'invoicing'), 
	'o_used_card_profit_report'			=> array('lang' => 'Can view used card profit report', 		'cat' => 'invoicing'), 
	
	// Owner Feature Admin
//	'o_feature_admin'			=> array('lang' => 'Can view feature administration',	'cat' => 'feature_administration'), // 6
	'o_features_read'			=> array('lang'	=> 'Can view features',					'cat' => 'feature_administration'), // 19
	'o_features'				=> array('lang'	=> 'Can manage features',				'cat' => 'feature_administration'),
	'o_feature_offerings_read'	=> array('lang'	=> 'Can view feature offerings',		'cat' => 'feature_administration'), // 21
	'o_feature_offerings'		=> array('lang'	=> 'Can manage feature offerings',		'cat' => 'feature_administration'),

	// Owner Device Admin
	'o_device'							=> array('lang' => 'Can view device administration','cat' => 'device_administration'), // 6
	'o_device_features_read'			=> array('lang'	=> 'Can view device features', 		'cat' => 'device_administration'), // 19
	'o_device_features'					=> array('lang'	=> 'Can manage features',			'cat' => 'device_administration'),
	'o_define_device_offerings_read'	=> array('lang'	=> 'Can view device offerings',		'cat' => 'device_administration'), // 21
	'o_define_device_offerings'			=> array('lang'	=> 'Can manage device offerings',	'cat' => 'device_administration'),
	'o_did_maint_read'					=> array('lang'	=> 'Can view DID\'s',				'cat' => 'device_administration'), // 21
	'o_did_maint'						=> array('lang'	=> 'Can manage DID\'s',				'cat' => 'device_administration'),
	'o_did_vendor_maint'				=> array('lang'	=> 'Can manage DID Vendors',		'cat' => 'device_administration'),
	'o_did_vendor_maint_read'			=> array('lang'	=> 'Can view DID Vendors',			'cat' => 'device_administration'),
	'o_lot_pricing'						=> array('lang'	=> 'Can manage DID Lot Pricing',	'cat' => 'device_administration'),
	'o_lot_pricing_read'				=> array('lang'	=> 'Can view DID Lot Pricing',		'cat' => 'device_administration'),
	'o_did_inv_report'					=> array('lang'	=> 'Can manage DID Inventory Report',	'cat' => 'device_administration'),
	'o_did_inv_report_read'				=> array('lang'	=> 'Can view DID Inventory Report',	'cat' => 'device_administration'),
	'o_did_research'					=> array('lang'	=> 'Can manage DID Research',		'cat' => 'device_administration'),
	'o_did_research_read'				=> array('lang'	=> 'Can view DID Research',			'cat' => 'device_administration'),

	// Owner administration
	'o_administration'			=> array('lang' => 'Can view administration',		'cat' => 'administration'), // 8
	'o_user_maintenance_read'	=> array('lang'	=> 'Can view user maintenance',		'cat' => 'administration'), // 26 
	'o_user_maintenance'		=> array('lang'	=> 'Can manage users',				'cat' => 'administration'),  
	'o_transaction_log_read'	=> array('lang'	=> 'Can view transaction logs',		'cat' => 'administration'), // 28
//	'o_transaction_log'			=> array('lang'	=> 'Can manage transaction logs',	'cat' => 'administration'),
	'o_feature_types'			=> array('lang'	=> 'Can manage feature types',		'cat' => 'administration'), // 29
	'o_feature_types_read'		=> array('lang'	=> 'Can view feature types',		'cat' => 'administration'), // 29
	'o_feature_types_log'		=> array('lang'	=> 'Can manage feature types',		'cat' => 'administration'),
	'o_lawful_intercept_read'	=> array('lang' => 'Can view lawful intercept',		'cat' => 'administration'), //105
	'o_lawful_intercept'		=> array('lang' => 'Can manage lawful intercept',	'cat' => 'administration'),
	'o_download_log_read'		=> array('lang'	=> 'Can view reseller download log','cat' => 'administration'), //117

	// Owner permissions
	'o_permissions'		=> array('lang' => 'Can view permissions',			'cat' => 'permissions'), // 96
	'o_overview'		=> array('lang' => 'Can view overview',				'cat' => 'permissions'), // 97
	'o_users_read'		=> array('lang' => 'Can view user permissions',		'cat' => 'permissions'), // 98
	'o_users'			=> array('lang' => 'Can manage user permissions',	'cat' => 'permissions'),
	'o_roles_read'		=> array('lang' => 'Can view permission roles',		'cat' => 'permissions'), // 99
	'o_roles'			=> array('lang' => 'Can manage permission roles',	'cat' => 'permissions'),

));

// User Permissions
$lang = array_merge($lang, array(
	// Reseller rates
	'r_rates'						=> array('lang' => 'Can view rates',					'cat' => 'rates'),
	'r_authorize_rate_change_read'	=> array('lang'	=> 'Can view authorize rate changes',	'cat' => 'rates'),
	'r_authorize_rate_change'		=> array('lang'	=> 'Can manage authorize rate changes',	'cat' => 'rates'),
	'r_rate_maintenance_read'		=> array('lang'	=> 'Can view rate maintenance',			'cat' => 'rates'),
	'r_rate_maintenance'			=> array('lang'	=> 'Can manage rate maintenance',		'cat' => 'rates'),
	'r_misc_features_read'			=> array('lang'	=> 'Can view misc features',			'cat' => 'rates'),
	'r_misc_features'				=> array('lang'	=> 'Can manage misc features',			'cat' => 'rates'),
	'r_restriction_plan_read'		=> array('lang'	=> 'Can view resriction plans',			'cat' => 'rates'),
	'r_restriction_plan'			=> array('lang'	=> 'Can manage view resriction plans',	'cat' => 'rates'),
	'r_rate_offerings_read'			=> array('lang'	=> 'Can view rate offerings',			'cat' => 'rates'),
	'r_rate_offerings'				=> array('lang'	=> 'Can manage rate offerings',	    	'cat' => 'rates'),

	// Reseller charges
	'r_charges'						=> array('lang' => 'Can view charges',					'cat' => 'charges'),
	'r_tax_plan_read'				=> array('lang'	=> 'Can view tax plans',				'cat' => 'charges'),
	'r_tax_plan'					=> array('lang'	=> 'Can manage tax plans',				'cat' => 'charges'),
	'r_billplan_read'				=> array('lang'	=> 'Can view bill plans',				'cat' => 'charges'),
	'r_billplan'					=> array('lang'	=> 'Can manage bill plans',				'cat' => 'charges'),
	'r_discount_plan_read'			=> array('lang'	=> 'Can view discount plans',			'cat' => 'charges'),
	'r_discount_plan'				=> array('lang'	=> 'Can manage discount plans',			'cat' => 'charges'),
	'r_maintenance_fee_plan_read'	=> array('lang'	=> 'Can view maintenance fee plans',	'cat' => 'charges'),
	'r_maintenance_fee_plan'		=> array('lang'	=> 'Can manage maintenance fee plans',	'cat' => 'charges'),
	'r_pay_phone_charge_read'		=> array('lang'	=> 'Can view pay phone charge',			'cat' => 'charges'),
	'r_pay_phone_charge'			=> array('lang'	=> 'Can manage pay phone charge',		'cat' => 'charges'),

	// Reseller administration
	'r_administration'			=> array('lang' => 'Can view administration',		'cat' => 'administration'),
	'r_transaction_log_read'	=> array('lang'	=> 'Can view transaction logs',		'cat' => 'administration'),
	'r_invoice_data_export'		=> array('lang'	=> 'Can view invoice data export',	'cat' => 'administration'),
	'r_user_maintenance_read'	=> array('lang'	=> 'Can view user maintenance',		'cat' => 'administration'),
	'r_user_maintenance'		=> array('lang'	=> 'Can manage users',				'cat' => 'administration'),
	
	// Reseller Invoicing
	'r_invoicing'				=> array('lang' => 'Can view invoicing',				'cat' => 'invoicing'),	
	'r_view_invoices_read'		=> array('lang'	=> 'Can view invoices',					'cat' => 'invoicing'),

	// Reseller Feature Administration
//	'r_feature_admin'			=> array('lang' => 'Can view feature administration',	'cat' => 'feature_administration'),
	'r_features'				=> array('lang'	=> 'Can manage features',				'cat' => 'feature_administration'),
	'r_features_read'			=> array('lang'	=> 'Can view features',					'cat' => 'feature_administration'),
	'r_feature_offerings_read'	=> array('lang'	=> 'Can view feature offerings',		'cat' => 'feature_administration'),
	'r_feature_offerings'		=> array('lang'	=> 'Can manage feature offerings',		'cat' => 'feature_administration'),

	// Reseller Template Management
	'r_template_images'				=> array('lang'	=> 'Can manage template images',		'cat' => 'templates'),
	'r_template_images_read'		=> array('lang'	=> 'Can view template images',			'cat' => 'templates'),
	'r_template_maintenance'		=> array('lang' => 'Can manage template maintance',		'cat' => 'templates'),
	'r_template_maintenance_read'	=> array('lang'	=> 'Can view template maintance',		'cat' => 'templates'),
	'r_template_assignments'		=> array('lang' => 'Can manage template assignments',	'cat' => 'templates'),
	'r_template_assignments_read'	=> array('lang'	=> 'Can view template assignments',		'cat' => 'templates'),
	

	// Reseller Device Admin
	'r_device'							=> array('lang' => 'Can view device administration',	'cat' => 'device_administration'), 
	'r_set_device_availability_read'	=> array('lang'	=> 'Can view device availability', 		'cat' => 'device_administration'),
	'r_set_device_availability'			=> array('lang'	=> 'Can manage device availability',	'cat' => 'device_administration'),
	'r_device_features_read'			=> array('lang'	=> 'Can view device features', 			'cat' => 'device_administration'), 
	'r_device_features'					=> array('lang'	=> 'Can manage features',				'cat' => 'device_administration'),
	'r_define_device_offerings_read'	=> array('lang'	=> 'Can view device offerings',			'cat' => 'device_administration'), 
	'r_define_device_offerings'			=> array('lang'	=> 'Can manage device offerings',		'cat' => 'device_administration'),
	'r_request_dids_read'				=> array('lang'	=> 'Can view DID request page',			'cat' => 'device_administration'), 
	'r_request_dids'					=> array('lang'	=> 'Can manage DID request page',		'cat' => 'device_administration'),

	// Reseller permissions
	'r_permissions'		=> array('lang' => 'Can view permissions',			'cat' => 'permissions'),
	'r_overview'		=> array('lang' => 'Can view overview',				'cat' => 'permissions'),
	'r_users_read'		=> array('lang' => 'Can view user permissions',		'cat' => 'permissions'),
	'r_users'			=> array('lang' => 'Can manage user permissions',	'cat' => 'permissions'),
	'r_roles_read'		=> array('lang' => 'Can view permission roles',		'cat' => 'permissions'),
	'r_roles'			=> array('lang' => 'Can manage permission roles',	'cat' => 'permissions'),

	// Reseller DIDs
	'r_request_dids'			=> array('lang' => 'Can manage DID requests',		'cat' => 'dids'),
	'r_request_dids_read'		=> array('lang' => 'Can view DID requests',			'cat' => 'dids'),
	'r_assign_dids'				=> array('lang' => 'Can manage DID assignments',	'cat' => 'dids'),
	'r_assign_dids_read'		=> array('lang' => 'Can view DID assignments',		'cat' => 'dids'),
	'r_did_inv_report'			=> array('lang' => 'Can manage DID inventory',		'cat' => 'dids'),
	'r_did_inv_report_read'		=> array('lang' => 'Can view DID inventory',		'cat' => 'dids'),
	'r_access_num_maint_read'	=> array('lang'	=> 'Can view Access Numbers',		'cat' => 'dids'),
	'r_access_num_maint'		=> array('lang'	=> 'Can manage Access Numbers',		'cat' => 'dids'),
	'r_dnis_maintenance_read'	=> array('lang'	=> 'Can view DNIS Restriction Plan',		'cat' => 'dids'),
	'r_dnis_maintenance'		=> array('lang'	=> 'Can manage DNIS Restriction Plan',	'cat' => 'dids'),
	'r_access_charge_read'		=> array('lang'	=> 'Can view DNIS charge plan',		'cat' => 'dids'),
	'r_access_charge'			=> array('lang'	=> 'Can manage DNIS charge plan',	'cat' => 'dids'),

	// Credit Card Management
	'r_cc_merchant_maint'		=> array('lang' => 'Can manage Merchants',				'cat' => 'credit_mgmt'),
	'r_cc_merchant_maint_read'	=> array('lang' => 'Can view Merchants',				'cat' => 'credit_mgmt'),
	'r_cc_trans_type'			=> array('lang' => 'Can manage Transaction Types',		'cat' => 'credit_mgmt'),
	'r_cc_trans_type_read'		=> array('lang' => 'Can view Tranaction Types',			'cat' => 'credit_mgmt'),
	'r_cc_trans_auth'			=> array('lang' => 'Can manage Transactions',			'cat' => 'credit_mgmt'),
	'r_cc_trans_auth_read'		=> array('lang' => 'Can view Transactions',				'cat' => 'credit_mgmt'),
	'r_cc_blacklist'			=> array('lang' => 'Can manage Blacklist',				'cat' => 'credit_mgmt'),
	'r_cc_blacklist_read'		=> array('lang' => 'Can view Blacklist',				'cat' => 'credit_mgmt'),
	'r_cc_trans_report'			=> array('lang' => 'Can manage Transaction Report',		'cat' => 'credit_mgmt'),
	'r_cc_trans_report_read'	=> array('lang' => 'Can view Transaction Report',		'cat' => 'credit_mgmt'),
	'r_cc_trans_type_set'		=> array('lang' => 'Can manage Site Transaction Types',	'cat' => 'credit_mgmt'),
	'r_cc_trans_type_set_read'	=> array('lang' => 'Can view Site Transaction Types',	'cat' => 'credit_mgmt'),


	// Reseller Agent Admin
	'r_agent_administration'		=> array('lang' => 'Can view Residential VoIP administration',	'cat' => 'agent_admin'),
	'r_product_maintenance_read'	=> array('lang' => 'Can view Residential VoIP Products',		'cat' => 'agent_admin'),
	'r_product_maintenance'			=> array('lang'	=> 'Can manage Residential VoIP Products',		'cat' => 'agent_admin'),
	'r_agent_summary'				=> array('lang' => 'Can view Residential VoIP summary',			'cat' => 'agent_admin'),
	'r_agent_maintenance_read'		=> array('lang' => 'Can view Residential VoIP Business',		'cat' => 'agent_admin'),
	'r_agent_maintenance'			=> array('lang' => 'Can manage Residential VoIP Business',		'cat' => 'agent_admin'),

	// Reseller Enterprise Admin
	'r_enterprise_administration'	=> array('lang' => 'Can view enterprise administration',		'cat' => 'enterprise_admin'),
	'r_enterprise_summary'			=> array('lang' => 'Can view enterprise summary',				'cat' => 'enterprise_admin'),
	'r_enterprise_package_read'		=> array('lang' => 'Can view enterprise packages',				'cat' => 'enterprise_admin'),
	'r_enterprise_package'			=> array('lang'	=> 'Can manage enterprises packages',			'cat' => 'enterprise_admin'),
	'r_enterprise_maintenance_read'	=> array('lang' => 'Can view enterprise maintenance',			'cat' => 'enterprise_admin'),
	'r_enterprise_maintenance'		=> array('lang'	=> 'Can manage enterprises maintenance',		'cat' => 'enterprise_admin'),
	'r_location_maintenance_read'	=> array('lang' => 'Can view locations',						'cat' => 'enterprise_admin'),
	'r_location_maintenance'		=> array('lang' => 'Can manage locations',						'cat' => 'enterprise_admin'),

	// Reseller Sip Trunk Admin
	//'r_enterprise_administration'	=> array('lang' => 'Can view enterprise administration',	'cat' => 'sip_trunk_admin'),
	'r_sip_trunk_summary'				=> array('lang' => 'Can view sip trunk summary',			'cat' => 'sip_trunk_admin'),
	'r_sip_trunk_package_read'			=> array('lang' => 'Can view sip trunk packages',			'cat' => 'sip_trunk_admin'),
	'r_sip_trunk_package'				=> array('lang'	=> 'Can manage sip trunk packages',			'cat' => 'sip_trunk_admin'),
	'r_sip_trunk_maintenance_read'		=> array('lang' => 'Can view sip trunk maintenance',		'cat' => 'sip_trunk_admin'),
	'r_sip_trunk_maintenance'			=> array('lang'	=> 'Can manage sip trunk maintenance',		'cat' => 'sip_trunk_admin'),
	'r_sip_trunk_loc_maintenance_read'	=> array('lang' => 'Can view sip trunk locations',			'cat' => 'sip_trunk_admin'),
	'r_sip_trunk_loc_maintenance'		=> array('lang' => 'Can manage sip trunk locations',		'cat' => 'sip_trunk_admin'),

	// Reseller Subscriber
	'r_maintain_read'		=> array('lang' => 'Can view subscribers',				'cat' => 'subscriber'),
	'r_maintain'			=> array('lang' => 'Can manage subscribers',			'cat' => 'subscriber'),
	'r_voicemail_admin'		=> array('lang' => 'Can manage voicemail',				'cat' => 'subscriber'),
	'r_view_charges'		=> array('lang' => 'Can view charges',					'cat' => 'subscriber'),
	'r_call_forwarding'		=> array('lang' => 'Can manage advance call forwarding','cat' => 'subscriber'),
	'r_line_maintenance'	=> array('lang' => 'Can manage subscriber and phones',	'cat' => 'subscriber'),
	'r_features'			=> array('lang' => 'Can manage subscribed features',	'cat' => 'subscriber'),
	
	// Reseller DNIS
	'r_dnis'					=> array('lang' => 'Can view DNIS Admin',			'cat' => 'dnis'),
	'r_dnis_maintenance_read'	=> array('lang'	=> 'Can view DNIS Restriction Plan',		'cat' => 'dnis'),
	'r_dnis_maintenance'		=> array('lang'	=> 'Can manage DNIS Restriction Plan',	'cat' => 'dnis'),
	'r_access_charge_read'		=> array('lang'	=> 'Can view DNIS charge plan',		'cat' => 'dnis'),
	'r_access_charge'			=> array('lang'	=> 'Can manage DNIS charge plan',	'cat' => 'dnis'),
	
	// Reseller Calling Card
	'r_retailcard_administration'			=> array('lang' => 'Can view calling card business administration',	'cat' => 'retailcard_admin'),
	'r_retailcard_summary'					=> array('lang' => 'Can view calling card business summary',		'cat' => 'retailcard_admin'),
	'r_retailcard_product_maintenance_read'	=> array('lang' => 'Can view products',								'cat' => 'retailcard_admin'),
	'r_retailcard_product_maintenance'		=> array('lang'	=> 'Can manage products',							'cat' => 'retailcard_admin'),
	'r_retailcard_maintenance_read'			=> array('lang' => 'Can view calling card businesses',				'cat' => 'retailcard_admin'),
	'r_retailcard_maintenance'				=> array('lang' => 'Can manage calling card businesses',			'cat' => 'retailcard_admin'),
	
	// Reseller CARD SUBSCRIBERS
    'r_card_subscriber'					=> array('lang' => 'Can view card subscribers',	'cat' => 'card_subscriber'),
    'r_card_template_maintenance_read'  => array('lang' => 'Can view card template', 	'cat' => 'card_subscriber'),
	'r_card_template_maintenance'		=> array('lang' => 'Can manage card template', 	'cat' => 'card_subscriber'),
    'r_card_batch_maintenance_read'		=> array('lang' => 'Can view card batches', 	'cat' => 'card_subscriber'),
    'r_card_batch_maintenance'			=> array('lang' => 'Can manage card batches', 	'cat' => 'card_subscriber'),
    'r_card_generation'					=> array('lang' => 'Can manage card generation','cat' => 'card_subscriber'),
    'r_maintain_card_subscriber_read'	=> array('lang' => 'Can view card subscriber', 	'cat' => 'card_subscriber'),
    'r_maintain_card_subscriber'		=> array('lang' => 'Can manage card subscriber','cat' => 'card_subscriber'),
	'r_export_cards'					=> array('lang'	=> 'Can manage card export',	'cat' => 'card_subscriber'),
	'r_card_status_maintenance'			=> array('lang'	=> 'Can manage card status',	'cat' => 'card_subscriber'),
    
	// Reseller Call Shop
	'r_call_shop_group_maint_read'			=> array('lang' => 'Can view Call Shop Groups',				'cat' => 'call_shop'),
	'r_call_shop_group_maint'				=> array('lang' => 'Can manage Call Shop Groups',			'cat' => 'call_shop'),
	'r_common_profitability_summary_read'  	=> array('lang' => 'Can view profitability summary report',	'cat' => 'call_shop'),

	// Reseller ANI Card
	'r_ani_administration'				=> array('lang' => 'Can view ANI business administration',	'cat' => 'ani_admin'),
	'r_ani_summary'						=> array('lang' => 'Can view ANI business summary',			'cat' => 'ani_admin'),
	'r_ani_product_maintenance_read'	=> array('lang' => 'Can view products',						'cat' => 'ani_admin'),
	'r_ani_product_maintenance'			=> array('lang'	=> 'Can manage products',					'cat' => 'ani_admin'),
	'r_ani_maintenance_read'			=> array('lang' => 'Can view ANI business',				'cat' => 'ani_admin'),
	'r_ani_maintenance'					=> array('lang' => 'Can manage ANI business',				'cat' => 'ani_admin'),
	
 	// Reseller ANI Subscribers
    'r_ani_subscriber'              	   => array('lang' => 'Can view ANI subscribers', 'cat' => 'ani_subscriber'),
	'r_ani_subscriber_maintenance_read'    => array('lang' => 'Can view ANI subscriber maintenance', 'cat' => 'ani_subscriber'),
	'r_ani_subscriber_maintenance'         => array('lang' => 'Can manage ANI subscriber maintenance', 'cat' => 'ani_subscriber'),
	'r_upload_bulk_ani'        			   => array('lang' => 'Can manage Bulk Upload ANI Subscribers', 'cat' => 'ani_subscriber'),
	
	// Reseller Calling card reports
    'r_reports'							=> array('lang' => 'Can view Reports', 'cat' => 'reports'),
	'r_rated_call_record_read'   	 	=> array('lang' => 'Can view rated call records', 'cat' => 'reports'),
	'r_first_use_report_read'   	 	=> array('lang' => 'Can view first use report', 'cat' => 'reports'),
	'r_first_use_detailed_report_read'  => array('lang' => 'Can view first use detailed report', 'cat' => 'reports'),
	'r_profitability_summary_read'  	=> array('lang' => 'Can view profitability summary report', 'cat' => 'reports'),
	'r_card_usage_summary_read'  		=> array('lang' => 'Can view card usage summary report', 'cat' => 'reports'),
	'r_call_detail_report_read'  		=> array('lang' => 'Can view Call Detail report', 'cat' => 'reports'),
	'r_asr_report_read'  				=> array('lang' => 'Can view ASR report', 'cat' => 'reports'),
	'r_activation_breakout_read'		=> array('lang' => 'Can view activation breakout report', 'cat' => 'reports'),
	'r_lot_liability_report_read'		=> array('lang' => 'Can view lot liability Report', 'cat' => 'reports'),
	'r_used_card_profit_report_read'		=> array('lang' => 'Can view used card profit Report', 'cat' => 'reports'),
	'r_maintenance_fee_report_read'		=> array('lang' => 'Can view Maintenance Fee Report', 'cat' => 'reports'),
	
	// Reseller ANI reports
    'r_reports'							=> array('lang' => 'Can view Reports', 'cat' => 'ani_reports'),
    'r_ani_asr_report_read'  			=> array('lang' => 'Can view ASR report', 'cat' => 'ani_reports'),
	'r_ani_rated_call_record_read'   	=> array('lang' => 'Can view rated call records', 'cat' => 'ani_reports'),
	'r_ani_call_detail_report_read'  	=> array('lang' => 'Can view Call Detail report', 'cat' => 'ani_reports'),
	'r_ani_profitability_summary_read'  	=> array('lang' => 'Can view ANI profitability summary report', 'cat' => 'ani_reports'),
	// Reseller Enterprise reports
    'r_reports'					=> array('lang' => 'Can view Reports', 'cat' => 'enterprise_reports'),
    'r_enterprise_profitability_summary_read'          => array('lang' => 'Can view enterprise profitability summary report', 'cat' => 'enterprise_reports'),
	// Residential reports
    'r_reports'					=> array('lang' => 'Can view Reports', 'cat' => 'retail_reports'),
    'r_retail_profitability_summary_read'          => array('lang' => 'Can view residential profitability summary report', 'cat' => 'retail_reports'),
));

?>
