<?php
/**
*
* @package consumer
* @version $Id: index.php,v 1.2 2010/08/20 16:50:06 lsmith Exp $
* @copyright (c) 2005 phpBB Group
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_ENTICE', true);
$common_path = (defined('COMMON_PATH')) ? COMMON_PATH : './../common/';
$web_common_path = (defined('WEB_COMMON_PATH')) ? WEB_COMMON_PATH : './../web_commons/';
$entice_root_path = (defined('ENTICE_ROOT_PATH')) ? ENTICE_ROOT_PATH : './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($common_path . 'common.' . $phpEx);

// Start session management
$user->session_begin();
auth::acl($user->data);
$user->setup('index');

$mode = request_var('mode', '');

if ($mode == 'login' || $mode == 'logout')
{
	define('IN_LOGIN', true);
}

if ($mode == 'logout')
{
	$user->session_kill();
	if ($user->data['user_id'] != ANONYMOUS && isset($_GET['sid']) && !is_array($_GET['sid']) && $_GET['sid'] === $user->session_id)
	{
		$user->session_kill();
		$user->session_begin();
		$message = $user->lang['LOGOUT_REDIRECT'];
	}
	else
	{
		$message = ($user->data['user_id'] == ANONYMOUS) ? $user->lang['LOGOUT_REDIRECT'] : $user->lang['LOGOUT_FAILED'];
	}
	meta_refresh(3, append_sid("{$entice_root_path}index.$phpEx"));

	$message = $message . '<br /><br />' . sprintf($user->lang['RETURN_INDEX'], '<a href="' . append_sid("{$entice_root_path}index.$phpEx") . '">', '</a> ');
	trigger_error($message);
}

// Only registered users can go beyond this point
if (!$user->data['is_registered'])
{
	login_box('main.' . $phpEx, $user->lang['LOGIN_EXPLAIN_ENTICE'], $user_role);
}

// Assign index specific vars
$template->assign_vars(array(
	'S_LOGIN_ACTION'			=> append_sid("{$entice_root_path}index.$phpEx", 'mode=login'),
));

// take the user to the self service page...
redirect(append_sid("{$entice_root_path}main.$phpEx"));

// if we decide to not redirect the user, delete the above line, and use the index_body.html
// Output page
page_header($user->lang['INDEX']);

$template->set_filenames(array(
	'body' => 'index_body.html')
);

page_footer();

?>