<?php
/**
* @author Lor Smith
* @package pbx modules
* @version $Id: contact.php,v 1.10 2011/03/08 23:33:37 lor Exp $
* @copyright (c) 2007 Stratus Technologies
* @license Stratus Technologies
*
*/

require_once ($GLOBALS['common_path'] . 'classes/ContactClass.php');

class contactAdmin {
	public $u_action;
	private $details_array = array(
		'firstname'		=> '',
		'lastname'		=> '',
		'phone_num'		=> '',
		'fax_num'		=> '',
		'company'		=> '',
		'address1'		=> '',
		'address2'		=> '',
		'address3'		=> '',
		'city'			=> '',
		'state'			=> '',
		'postal'		=> '',
		'country'		=> '',
	);

	function main($id, $mode) {
		global $soap, $template, $user, $config;

		$action	= request_var('action', '');
		$cust_id = $user->data['cust_id'];

		//validation of required field
		if ( post_var('validate_data') ) {
			$this->details_array = $this->request_var($this->details_array);
			$error = $this->is_valid_loc_data($this->details_array);
			return_error_data($error);
		}
		if ( post_var('update_contact') && $action != 'ajax_emergency' ) {
			$cont_id = request_var('cont_id', 0);

			$ct_bean = new contact_bean();
			$ct_bean->custId = $user->data['cust_id'];
			$ct_bean->acctId = $user->data['acct_id'];
			$ct_bean->contactTypeId = CONTACT_PRIMARY;
			$ct_bean->firstName = request_var('firstname', '');
			$ct_bean->lastName = request_var('lastname', '');
			$ct_bean->title = request_var('title', '');
			$ct_bean->phoneNum = request_var('phone_num', '');
			$ct_bean->email = request_var('email', '');
			$ct_bean->company = request_var('company', '');
			$ct_bean->address1 = request_var('address1', '');
			$ct_bean->address2 = request_var('address2', '');
			$ct_bean->address3 = request_var('address3', '');
			$ct_bean->city = request_var('city', '');
			$ct_bean->state = request_var('state', '');
			$ct_bean->postal = request_var('postal', '');
			$ct_bean->country = request_var('country', '');

			if ( $cont_id ) {
				$ct_bean->contId = $cont_id;
				$status = 'billing3';
				$result = $soap->send(UPDATE_ACCT_CONTACT, array($ct_bean), $status);
				confirmation_box($status, 'PRIMARY_SAVED');
			}
			else {
				$status = 'billing3';
				$result = $soap->send(ADD_ACCT_CONTACT, array($ct_bean), $status);
				confirmation_box($status, 'PRIMARY_SAVED');
			}

			$sec_cont_id = request_var('secondary_cont_id', 0);

			$ct_bean = new contact_bean();
			$ct_bean->custId = $user->data['cust_id'];
			$ct_bean->acctId = $user->data['acct_id'];
			$ct_bean->contactTypeId = CONTACT_SECONDARY;
			$ct_bean->firstName = request_var('secondary_firstname', '');
			$ct_bean->lastName = request_var('secondary_lastname', '');
			$ct_bean->title = request_var('secondary_title', '');
			$ct_bean->phoneNum = request_var('secondary_phone_num', '');
			$ct_bean->email = request_var('secondary_email', '');
			$ct_bean->company = request_var('secondary_company', '');
			$ct_bean->address1 = request_var('secondary_address1', '');
			$ct_bean->address2 = request_var('secondary_address2', '');
			$ct_bean->address3 = request_var('secondary_address3', '');
			$ct_bean->city = request_var('secondary_city', '');
			$ct_bean->state = request_var('secondary_state', '');
			$ct_bean->postal = request_var('secondary_postal', '');
			$ct_bean->country = request_var('secondary_country', '');

			if ( $sec_cont_id ) {
				$ct_bean->contId = $sec_cont_id;
				$status = 'billing3';
				$result = $soap->send(UPDATE_ACCT_CONTACT, array($ct_bean), $status);
				confirmation_box($status, 'SECONDARY_SAVED');
			}
			else {
				$status = 'billing3';
				$result = $soap->send(ADD_ACCT_CONTACT, array($ct_bean), $status);
				confirmation_box($status, 'SECONDARY_SAVED');
			}

			$bill_cont_id = request_var('billing_cont_id', 0);
		}

		switch ($action) {
			case 'ajax_emergency':
				$filter = '';
				if ( isset($user->data['esc_layer']) ) {
					$esc_layer = $user->data['esc_layer'];
				}
				else {
					$esc_layer = array();
				}

				$found_mismatch = false;
				$layer1 = 0;
				foreach ($esc_layer as $layer_key => $layer_val) {
					if ( !$found_mismatch ) {
						$web_val = request_var('layer_'.$layer_key, '');
						if ( $web_val === '0' ) {
							$esc_layer[$layer_key] = false;
							$found_mismatch = true;
						}
						else {
							if ( $web_val != $layer_val ) {
								$esc_layer[$layer_key] = $web_val;
								$status = 'entice';
								$result = $soap->send(GET_EMERGENCY_ADDR_LOOKUP, array($filter), $status);
								$this->build_layer_select($layer1, $layer_key, $web_val, $result);
								$found_mismatch = true;
							}
							else {
								$status = 'entice';
								$result = $soap->send(GET_EMERGENCY_ADDR_LOOKUP, array($filter), $status);
								$this->build_layer_select($layer1, $layer_key, $web_val, $result);
							}
							$filter .= strtoupper($layer_key).'|'.$web_val.'|';
							$layer1++;
						}
					}
					else {
						unset($esc_layer[$layer_key]);
					}
				}

				$status = 'entice';
				$result = $soap->send(GET_EMERGENCY_ADDR_LOOKUP, array($filter), $status);
				if (sizeof($result)) {
					$array_keys = array_keys($result[0]);
					$layer2 = 0;
					foreach ($array_keys as $key) {
						if (!isset($esc_layer[$key]) || $esc_layer[$key] == '') {
							$esc_layer[$key] = false;
							$this->build_layer_select($layer2, $key, $esc_layer[$key], $result);
						}
						$layer2++;
					}
					$_SESSION['esc_layer'] = $esc_layer;

					if ($layer1 == $layer2 && $esc_layer[$key]) {
						$status = 'billing3';
						$result = $soap->send(GET_ACCT_CONTACT, array($user->data['acct_id']), $status, false, true);
						( sizeof($result) )? $result = $result->data->row:'';

						foreach ($result as $row) {
							if ($row->CONTACT_TYPE_ID == CONTACT_EMERGENCY ) {
								$del_status = 'billing';
								$soap->send(DELETE_CONTACT, array($row->CONT_ID), $del_status);
							}
						}

						$esc_layer['layer_custId'] = $cust_id;
						$esc_layer['layer_acctId'] = $user->data['acct_id'];
						$cont_bean = new contact_bean($esc_layer, 'layer_');

						$add_status = 'billing3';
						$soap->send(ADD_ACCT_CONTACT, $cont_bean, $add_status);
						confirmation_box($add_status, 'UPDATE_EMERGENCY');
					}

					$status = 'billing3';
					$result = $soap->send(GET_ACCT_CONTACT, array($user->data['acct_id']), $status);
					foreach ($result as $row) {
						if ($row['contact_type_id'] == CONTACT_EMERGENCY ) {
							$this->format_emergency_label($row);
							break;
						}
					}

					$template->assign_vars(array(
						'AJAX_EMERGENCY'	=> true,
						'ESC_LAYER'			=> $layer2,
					));
				}
				break;
		}

		if ($action != 'ajax_emergency') {
			$status = 'billing3';
			$result = $soap->send(GET_ACCT_CONTACT, array($user->data['acct_id']), $status, false, true);

			if ( !$result->error ) {
				$result = $result->data->row;
				foreach ( $result as $cont ) {
					$contact_array = array(
						'CONT_ID'			=> $cont->CONT_ID,
						'FIRST_NAME'		=> $cont->FIRSTNAME,
						'LAST_NAME'			=> $cont->LASTNAME,
						'TITLE'				=> $cont->TITLE,
						'PHONE_NUM'			=> $cont->PHONE_NUM,
						'FAX_NUM'			=> $cont->FAX_NUM,
						'MOBILE_NUM'		=> $cont->MOBILE_NUM,
						'EMAIL'				=> $cont->EMAIL,
						'CONTACT_TYPE_ID'	=> $cont->CONTACT_TYPE_ID,
						'COMPANY'			=> $cont->COMPANY,
						'ADDRESS1'			=> $cont->ADDRESS1,
						'ADDRESS2'			=> $cont->ADDRESS2,
						'ADDRESS3'			=> $cont->ADDRESS3,
						'CITY'				=> $cont->CITY,
						'STATE'				=> $cont->STATE,
						'POSTAL'			=> $cont->POSTAL,
						'COUNTRY'			=> $cont->COUNTRY,
						'MISC'				=> $cont->MISC,
						'MODIFIED_DATE'		=> $cont->MODIFIED_DATE,
					);

					switch ($cont->CONTACT_TYPE_ID) {
						case CONTACT_PRIMARY:
							$template->assign_vars($contact_array);
						break;

						case CONTACT_SECONDARY:
							$new_contact_ary = array();
							foreach ($contact_array as $key => $var) {
								$new_contact_ary['SECONDARY_' . $key] = $var;
							}

							$template->assign_vars($new_contact_ary);
						break;

						case CONTACT_BILLING:
							$new_contact_ary = array();
							foreach ($contact_array as $key => $var) {
								$new_contact_ary['BILLING_' . $key] = $var;
							}

							$template->assign_vars($new_contact_ary);
						break;

						case CONTACT_EMERGENCY:
							$new_contact_ary = array();
							foreach ($contact_array as $key => $var) {
								$new_contact_ary['EMERGENCY_' . $key] = $var;
							}

							$template->assign_vars($new_contact_ary);
						break;

						case CONTACT_OTHER:
							$new_contact_ary = array();
							foreach ($contact_array as $key => $var) {
								$new_contact_ary['OTHER_' . $key] = $var;
							}

							$template->assign_vars($new_contact_ary);
						break;
					}
				}
			}
		}

		$template->assign_vars(array(
			'U_ACTION'			=> $this->u_action,
			'SHOW_EMERGENCY'    => isset($config['show_emergency'])?$config['show_emergency']:true,
            'U_AJAX_EMERGENCY'	=> $this->u_action.'&amp;action=ajax_emergency'
		));
	}

	function format_emergency_label($contact) {
		global $template, $user;
		$allowed_list = array('address1','address2','address3','city','state','postal','country','county','district');

		$eme_details = '';
		foreach ($contact as $key => $val) {
			if (in_array($key, $allowed_list) && $val != '') {
				$eme_details .= '<dt>'.$user->lang[strtoupper($key)] . '</dt><dd>' . $val . '</dd>';
			}
		}
		(strlen($eme_details) == 0)?$eme_details = $user->lang['NO_LOC_SELECTED']: '';

		$eme_label = '
		<h3 style="padding-left:10px;">'.$user->lang['CURRENT_EME_LOC'].'</h3>
		<fieldset><dl>'.$eme_details.'</dl></fieldset>';

		$template->assign_var('EMERGENCY_LABEL', $eme_label);
		return;
	}

	function build_layer_select($layer, $key, $value, $options) {
		global $user, $template;

		$layer_select = '<select id="layer_'.$key.'" name="layer_'.$key.'" onchange="send(\'submit\', \''.$this->u_action.'&amp;action=ajax_emergency\' , this.form, \'dyn_emergency\', true);">';
		$layer_select .= '<option value="0">'.$user->lang['SELECT_ONE'].'</option>';
		foreach ($options as $opt) {
			$layer_select .= '<option value="'.$opt[$key].'" '.(($opt[$key]==$value)?'selected':'').'>'.$opt[$key].'</option>';
		}
		$layer_select .= '</select>';

		$template->assign_vars(array(
			'LAYER_'.$layer.'_LANG'		=> $user->lang[strtoupper($key)],
			'LAYER_'.$layer.'_SELECT'	=> $layer_select,
		));

		return;
	}

	function request_var($var_array = array()) {
		if ( sizeof($var_array) ) {
			foreach ($var_array as $key => $default) {
				$mb_string = false;
				if (is_array($default)) {
					$mb_string = $default[1];
					$default = $default[0];
				}

				$data[$key] = request_var($key, $default, $mb_string);

				if ($mb_string) {
					$data[$key] = utf8_normalize_nfc($data[$key]);
				}
			}

			return $data;
		}
		return false;
	}

	function is_valid_loc_data($validate_ary) {
		global $common_path, $phpEx;

		require($common_path . 'includes/functions_user.' . $phpEx);
		$error = validate_data($validate_ary, array(
			'company'			=> array(
				array('string', false, 1, 384)),
			'firstname'			=> array(
				array('string', false, 1, 128 )),
			'lastname'			=> array(
				array('string', false, 1, 128 )),
			'phone_num'			=> array(
				array('string', false, 1, 24 )),
			'address1'			=> array(
				array('string', false, 1, 384 )),
			'city'			=> array(
				array('string', false, 1, 384 )),
			'state'			=> array(
				array('string', false, 1, 384 )),
			'postal'			=> array(
				array('string', false, 1, 60 )),
			'country'			=> array(
				array('string', false, 1, 384 )),
		));
		return $error;
	}
}

//class contact_bean {
//
//    public $acctId = null; // NUMBER(10,0)
//    public $address1 = null; // VARCHAR2(128) NULLABLE
//    public $address2 = null; // VARCHAR2(128) NULLABLE
//    public $address3 = null; // VARCHAR2(128) NULLABLE
//    public $subscriberId = null; // NUMBER(10,0) NULLABLE
//    public $city = null; // VARCHAR2(128) NULLABLE
//    public $company = null; // VARCHAR2(128) NULLABLE
//    public $contactTypeId = 5; // NUMBER(10,0) NOT NULL
//    public $contId = 0; // NUMBER(10,0) NOT NULL
//    public $country = null; // VARCHAR2(128) NULLABLE
//    public $custId = null; // NUMBER(10,0) NULLABLE
//    public $email = null; // VARCHAR2(255) NULLABLE
//    public $faxNum = null; // VARCHAR2(24) NULLABLE
//    public $firstName = null; // VARCHAR2(128) NULLABLE
//    public $lastName = null; // VARCHAR2(128) NULLABLE
//    public $misc = null; // VARCHAR2(256) NULLABLE
//    public $mobileNum = null; // VARCHAR2(24) NULLABLE
//    public $phoneNum = null; // VARCHAR2(24) NULLABLE
//    public $postal = null; // VARCHAR2(20) NULLABLE
//    public $state = null; // VARCHAR2(128) NULLABLE
//    public $title = null; // VARCHAR2(64) NULLABLE
//
//	function contact_bean($data = array(), $tag = '') {
//		if ( sizeof($data) ) {
//			foreach ($data as $item => $val) {
//				$local_item = str_replace($tag, '', $item);
//				$this->$local_item = $val;
//			}
//			$this->contactTypeId = CONTACT_EMERGENCY;
//		}
//	}
//}
?>