<?php
/**
* @author Lor Smith
* @package pbx modules
* @version $Id: centrex_users.php,v 1.24 2011/03/21 21:51:24 lor Exp $
* @copyright (c) 2007 Stratus Technologies
* @license Stratus Technologies
*
*/

/**
 * Class Includes
 */
require_once ($GLOBALS['common_path'] . 'classes/LocaleClass.php');

class centrex_users {
	public $u_action;

	function main($id, $mode) {
		global $soap, $user, $template, $config, $phpEx, $common_path;

		$acct_id	= $user->data['acct_id'];
		$cust_id	= $user->data['cust_id'];
		$pbx_role	= $user->data['pbx_role'];
		$screen		= request_var('screen', '');
		$action		= request_var('action', '');
		$auto_open  = false;
		$phone_type = '';
		$vm_type = '';

		if ( $pbx_role == 'pbx_admin' || $pbx_role == 'sip_admin' ) {
			$sub_id = request_var('sub_id', '');
			($sub_id == '')? $sub_id = 0: '';
		}
		else {
			$sub_id = $user->data['sub_id'];
		}
		// validation of required field
		if (post_var('validate_data')) {
			require($common_path . 'includes/functions_user.' . $phpEx);

			$validate_ary = array(
				'login_name'	=> request_var('login_name',  ''),
				'password'		=> request_var('password', ''),
				'email'			=> request_var('email', ''),
				'first_name'	=> request_var('first_name', ''),
				'last_name'		=> request_var('last_name', ''),
				'ep_alias'		=> request_var('ep_alias', ''),
				'ep_pin'		=> request_var('ep_pin', ''),
			);
			$error = validate_data($validate_ary, array(
				'login_name'	=> array(
					array('string', false, 1, 64)),
				'password'		=> array(
					array('string', false, 1, 64)),
				'email'			=> array(
					array('email', false )),
				'first_name'	=> array(
					array('string', false, 1, 128)),
				'last_name'		=> array(
					array('string', false, 1, 128)),
				'ep_alias'		=> array(
					array('string', true, 0, 32)),
				'ep_pin'		=> array(
					array('string', true, 0, 10)),
			));
			if ( 	strlen(request_var('ext', '')) == 0
			   && strlen(request_var('did', '')) == 0 ) {
			   	$error[] = "DID_EXT_REQUIRED";
			}
			return_error_data($error);
		}
		else {
			
			// Fetch whether access codes are enabled or not and assign to template
			$status = 'billing';
			$result = $soap->send('getCustomerById', array($cust_id), $status);
			if ( isset($result[0]['access_code_digits'])) {
				$access_code_digits = $result[0]['access_code_digits'];
			}
			else {
				$access_code_digits = 0;
			}
			$template->assign_var('ACCESS_CODE_DIGITS', $access_code_digits);
			
			//add update and delete actions happen first
			switch ($action) {
				case 'add':
					$xml = $this->add_subscriber();
					$status = 'billing3';
					$soap->send(ADD_SUBSCRIBER, array($xml->asXML()), $status, false, false, true);
					
					if ($status['error_message']) {
						if (request_var('access_code_always', '')) { $access_code_always = true; }
						else { $access_code_always = false; }
						
						if (request_var('assign_features', '')) { $assign_features = true; }
						else { $assign_features = false; }
						
						$template->assign_vars(array(
							'LOGIN_NAME'	=> request_var('login_name',  ''),
							'PASSWORD'		=> request_var('password',  ''),
							'EMAIL'			=> request_var('email',  ''),
							'FIRST_NAME'	=> request_var('first_name',  ''),
							'LAST_NAME'		=> request_var('last_name',  ''),
							'EXT'			=> request_var('ext',  ''),
							'DID'			=> request_var('did',  ''),
							'EP_ALIAS'		=> request_var('ep_alias', ''),
							'ALT_ID'		=> request_var('alt_id',  ''),
							'EP_PIN'		=> request_var('ep_pin', ''),
							'MAC_ADDRESS'	=> request_var('mac_address', ''),
							'ACCESS_CODE_ALWAYS'	=> $access_code_always,
							'ASSIGN_FEATURES'		=> $assign_features,
						));

						$phone_type = request_var('phone_type','');
						$vm_type = request_var('voicemail_subs','');
						$auto_open = true;
					}
					if (isset($config['sip_trunk']) && $config['sip_trunk']) {
						confirmation_box($status, 'SIP_TRUNK_SUCCESS', $xml->xpath('//USER_NAME'));
					}
					else {
						confirmation_box($status, 'SUCCESS', $xml->xpath('//USER_NAME'));
					}
					$action = 'details';
				break;

				case 'delete':
					$submit				= (isset($_REQUEST['submit'])) ? true : false;
					$referred_number	= request_var('referred_number', '');
					$delete_sub			= request_var('delete_sub', '');

					if (!$submit) {
						break;
					}

					if ($delete_sub == 'add_referral' && (!$referred_number)) {
						trigger_error($user->lang['REFERRED_NUMBERS_FILLED'] . back_link($this->u_action . '&amp;action=details'));
					}

					if ($delete_sub == 'add_referral') {
						$status = 'billing3';
						$result = $soap->send(GET_SUBSCRIBER_DETAILS_ID, array($sub_id), $status, false, true);
						if ( !$result->error ) {
							$dialed_numbers = $result->xpath('//phone/phoneline/NUMBER');
						}
						$status = 'billing3';
						$soap->send(TERMINATE_SUBSCRIBER, array($sub_id), $status, false, false, true);
						confirmation_box($status, $user->lang['SUBSCRIBER_DELETED']);

						// Get Subscriber Numbers and refer each of them.
						foreach ($dialed_numbers as $num) {
							$status_ref = 'entice';
							$soap->send(ADD_REFERRAL, array((string)$num, (string)$referred_number), $status_ref, false, false, true);
							$lang_subscriber_deleted = sprintf($user->lang['REFERRAL_ADDED'], $referred_number, (string)$num);	;
							confirmation_box($status_ref, $lang_subscriber_deleted);
						}
					}
					else {
						$status = 'billing3';
						$soap->send(DELETE_SUBSCRIBER, array(request_var('sub_id', '')), $status, false, false, true);
						confirmation_box($status, $user->lang['DELETE_SUBSCRIBER_SUCCESS']);
					}

					$action = 'details';
				break;
			}

			//now the viewing actions
			switch ($action) {
				//view line details popup
				case 'line_details':
					$xml_ary = array(
						request_var('sip', ''),
					);

					$status = 'entice';
					$xml = $soap->send(GET_SIP_ENDPOINT_STATUS, $xml_ary, $status, false, true, true);

					if (!$xml->error) {
						$xml = $xml->data->row->data;

						if (sizeof($xml)) {
							foreach ($xml as $row) {
								$template->assign_var(strtoupper(str_replace(' ', '_', $row->attributes())), $row);
							}
						}
					}
					$template->assign_vars(array(
						'DID'				=> preg_replace( '/[\D]/', '', preg_replace( '/[\D]/', '', request_var('did', ''))),
						'S_LINE_DETAILS'	=> true,
					));
				break;

				case 'details':
				default:
					$limit = request_var('limit', 25);
					$start = request_var('start', 0);
					$search = post_var('search');
					$filter = search_results('subscriber', $start);
					search_options('subscriber', array(
						'SUBSCRIBERS'	=> 'disabled',

						'firstname'		=> 'FIRST_NAME',
						'lastname'		=> 'LAST_NAME',
						'alt_id'		=> 'ALT_ID',
						'phone_id'		=> 'PHONE',
						'line_id'		=> 'LINE',
						'value'			=> 'DID_EXT',
					));

					if ($limit <= 0) {
						$limit = 25;
					}
					$page = ceil(($start + 1) / $limit);

					LocaleClass::getSupportedTimeZones(true, LocaleClass::getTimezoneSettingOf($cust_id, $acct_id, ''));
					LocaleClass::getSupportedLanguages(true, LocaleClass::getLanguageSettingOf($cust_id, $acct_id, ''));
					
					if ( $pbx_role == 'pbx_user' || $pbx_role == 'sip_user') {
						$filter .= 'SUBSCRIBER_ID|=|'.$sub_id.'|';
					}

					$array = array(
						$cust_id,
						$acct_id,
						$page,
						$limit,
						'', //sort field
						$filter, //filter
					);

					$status = 'billing3';
					$result = $soap->send(GET_SUBSCRIBER_ACCT_ID, $array, $status);

					foreach ($result as $row) {
						$service_status = 'billing3';
						$service_result = $soap->send(GET_ACTIVE_SERVICES, $row['subscriber_id'], $service_status, false, true);
						$voicemail_result = $service_result->xpath('//row[FEATURE_TYPE_ID = "4" and VIRTUAL_NUMBER = "'.$row['value'].'"]');

						$template->assign_block_vars('details', array(
							'ALT_ID'				=> $row['alt_id'],
							'EP_ALIAS'				=> $row['ep_alias'],
							'NAME'					=> $row['fullname'],
							'PHONE'					=> $row['phone_id'],
							'TYPE'					=> $row['phone_type'],
							'LINE'					=> $row['line_id'],
							'LINE_NUMBER'			=> $row['line_id'],
							'DID'					=> $row['value'],

							'IS_ACTIVE'				=> ($row['status'] % 10 >= 5) ? false : true,
							'HAS_VOICEMAIL'			=> sizeof($voicemail_result)? true : false,

							'U_LINE_DETAILS'		=> $this->u_action . '&amp;action=line_details&amp;did=' . $row['value'] . '&amp;sip=' . $row['ep_alias'],
							'U_EDIT_SUBSCRIBER'		=> str_replace('mode=' . $mode, 'mode=edit_subscriber', $this->u_action) . '&amp;sub_id=' . $row['subscriber_id'],
							'U_NETWORK_FEATURES'	=> str_replace('mode=' . $mode,'mode=network_features', $this->u_action) . '&amp;main_number=' . $row['value']. '&amp;ep_alias=' . $row['ep_alias']. '&amp;sub_id=' . $row['subscriber_id'],
							'U_VOICEMAIL_ADMIN'		=> str_replace('mode=' . $mode,'mode=voicemail_admin', $this->u_action) . '&amp;sub_id=' . $row['subscriber_id'],
							'U_LINE_MAINTENANCE'	=> str_replace('mode=' . $mode, 'mode=line_maintenance', $this->u_action) . '&amp;sub_id=' . $row['subscriber_id'],
							'U_ADVANCED_CALL_FORWARDING'	=> str_replace('mode=' . $mode, 'mode=call_forwarding', $this->u_action) . '&amp;sub_id=' . $row['subscriber_id'],
							'U_DELETE_SUBSCRIBER'	=> $this->u_action . '&amp;action=delete&amp;sub_id=' . $row['subscriber_id'],
							'U_SUBSCRIBED_FEATURES'	=> str_replace('mode=' . $mode, 'mode=features', $this->u_action) . '&amp;sub_id=' . $row['subscriber_id'],
						));
					}

					$template->assign_vars(array(
						'CUST_ID'		=> $cust_id,
						'ACCT_ID'		=> $acct_id,

						'PBX_ROLE'		=> $pbx_role,

						'SCREEN'		=> ($search)?'' : $screen,

					    // pagination
						'PAGINATION'	=> generate_pagination(str_replace('&amp;start=' . $start, '', $this->u_action . '&amp;action=details&amp;limit=' . $limit), $status['total_rows'], $limit, $start, true),
						'PAGE_NUMBER'	=> on_page($status['total_rows'], $limit, $start),
					));
				break;
			}

			$vm_stat = 'billing3';
			$vm_rslt = $soap->send(GET_FEATURE_OFFERINGS, array($cust_id, $acct_id), $vm_stat, false, true);
			$voicemail_offerings = $vm_rslt->xpath('//row[FEATURE_TYPE_ID = "4" and FEATURE_OFFERING_LEVEL = "1"]');

			$vm_select = '<select id="voicemail_subs" name="voicemail_subs">';
			$vm_select .= '<option value="0">'.$user->lang['NO_VOICEMAIL'].'</option>';
			foreach ( $voicemail_offerings as $option ) {
				$selected = ($option->FEATURE_OFFERING_ID == $vm_type) ? ' selected="selected"' : '';
				$vm_select .= '<option value="'.$option->FEATURE_OFFERING_ID.'"' . $selected . '>'.$option->FEATURE_NAME.'</option>';
			}
			$vm_select .= '</select>';

			if ($user->data['managed_did']) {
				// create did list for this customer
				$selectedDID = '';
				$opts = getDIDSelect($cust_id, request_var('did', ''), true );
				$template->assign_vars(array(
					'DID_OPTIONS' => $opts,
				));
			}

			$this->setPhone_types($cust_id, $phone_type);
			
			$template->assign_vars(array(
//				'DEVICE_LIST_OPTIONS'	=> $device_type,
//				'NO_PHONES'				=> $no_phones,
			
				'SIP_TRUNK'             => isset($config['sip_trunk'])?$config['sip_trunk']:false,
				'MANAGED_DID'			=> $user->data['managed_did'],
				'EXPOSE_EP_ALIAS'		=> isset($config['expose_epalias'])?$config['expose_epalias']:false,
				'EXPOSE_PIN'			=> isset($config['expose_pin'])?$config['expose_pin']:true,
				'HIDE_COLUMNS'			=> isset($config['hide_phone_line'])?$config['hide_phone_line']:false,
				'VOICEMAIL_SELECT'		=> $vm_select,
				'U_ADD_SUBSCRIBER'		=> $this->u_action . '&amp;action=details',
				'S_ACTION'				=> $action,
				'U_ACTION'				=> $this->u_action,
				'AUTOOPEN'				=> $auto_open,
				
			));
		}
	}

	function setPhone_types($cust_id, $current = '') {
		global $soap, $template, $config, $user;
		
		$status = 'autoprovisioning';
		$result = $soap->send(GET_PHONE_TYPE_AVAILABILITY, array(), $status, false, true);

		$result = $result->xpath('//row[AVAIL_TO_CUST_ID = "'.$cust_id.'" and AVAIL_TO_ACCT_ID=""]');

		$device_type = '<option value="'.$config['phone_type'].'">' . $user->lang['NO_DEVICE'] . '</option>';
		if ( sizeof($result) ) {
			foreach ($result as $option) {
				$selected = ($option->PHONE_TYPE == $current) ? ' selected="selected"' : '';
				$device_type .= '<option value="' . $option->PHONE_TYPE . '"' . $selected . '>' . $option->PHONE_TYPE . '</option>';
			}
			$no_phones = '0';
		}
		else {
			$no_phones = '1';
		}
		
		$template->assign_vars(array(
				'DEVICE_LIST_OPTIONS'	=> $device_type,
				'NO_PHONES'				=> $no_phones,
		));
	}
	
	function add_subscriber() {
		global $user, $config, $common_path, $phpEx;
		require($common_path . 'includes/functions_user.' . $phpEx);

		$cust_id	= $user->data['cust_id'];
		$acct_id	= $user->data['acct_id'];
		$feeplan_id	= $user->data['feeplan_id'];

		// grab some user input data
		$ep_pin = request_var('ep_pin', '');
		if (request_var('access_code_always', false)) {
			$access_code_always = 'true';
		}
		else {
			$access_code_always = 'false';
		}
		if (request_var('assign_features', false)) {
			$assign_features = 'true';
		}
		else {
			$assign_features = 'false';
		}
		$data = array(
			'login_name'	=> utf8_normalize_nfc(request_var('login_name', '', true)),
			'password'		=> request_var('password', '', true),
			'email'			=> request_var('email', ''),
			'first_name'	=> utf8_normalize_nfc(request_var('first_name', '', true)),
			'last_name'		=> utf8_normalize_nfc(request_var('last_name', '', true)),
			'ep_alias'		=> request_var('ep_alias', ''),
			'ep_pin'		=> $ep_pin,
			'alt_id'		=> request_var('alt_id', ''),
			'limit'			=> 0,
			'balance'		=> request_var('balance', 0),
			'did'			=> preg_replace( '/[\D]/', '', request_var('did', '')),
			'ext'			=> preg_replace( '/[\D]/', '', request_var('ext', '')),
			'voicemail'		=> request_var('voicemail_subs', 0),
			'access_code_always'	=> $access_code_always,
			'tz_id'			=> request_var('tz_select', 'UTC'),
			'language'		=> request_var('lang_select', 'en'),
		);

        if (  strlen($data['ep_alias']) == 0 && $config['sip_trunk'] == true ) {
			if ( strlen ( $data['did'] ) > 0 ) {
            	$data['ep_alias'] = $data['did'];
			}
			else {
            	$data['ep_alias'] = $user->data['cust_id'] . '_' . $data['ext'];
			}
        }

		$xml = new SimpleXMLElement('<EnticeRequest></EnticeRequest>');
		$xmldata = $xml->addChild('data');
		$row = $xmldata->addChild('row');

		$row->addChild('ACCT_ID', $acct_id);
		$row->addChild('CUST_ID', $cust_id);
		$row->addChild('BALANCE', $data['balance']);
		$row->addChild('STATUS', 12);
		$row->addChild('TTL', 0);
		$row->addChild('RESELLER_ID', $user->data['rsid']);
		$row->addChild('ERR_COUNTER', 0);
		$row->addChild('LIMIT', $data['limit']);
		$row->addChild('PREPAID_CARD_SEQ');
		$row->addChild('FEEPLAN_ID', $feeplan_id);
		$row->addChild('USER_NAME', $data['login_name']);
		$row->addChild('PASSWORD', $data['password']);
		$row->addChild('ALT_ID', $data['alt_id']);
		$row->addChild('PIN', $data['ep_pin']);
		$row->addChild('ACCESS_CODE_ALWAYS', $data['access_code_always']);
		$row->addChild('LANGUAGE', $data['language']);
		$row->addChild('TZ_ID', $data['tz_id']);

		$contact = $row->addChild('contact');
		$contact->addChild('LASTNAME', $data['last_name']);
		$contact->addChild('FIRSTNAME', $data['first_name']);
		$contact->addChild('EMAIL', $data['email']);
		$contact->addChild('CONTACT_TYPE_ID', 1);

		if ( strlen($data['ext']) || strlen($data['did']) ) {
			$phone = $row->addChild('phone');
			$phone->addChild('PHONE_ID', 1);
			$phone->addChild('MAC_ADDR',request_var('mac_address',''));
			$phone_type = request_var('phone_type','');
			if ( strlen($phone_type) == 0 ) {
	            $phone_type = $config['phone_type'];
	        }
			$phone->addChild('PHONE_TYPE', request_var('phone_type', $phone_type));
			$phone->addChild('ASSIGN_FEATURES', $assign_features);

			$phone_line = $phone->addChild('phoneline');
			$phone_line->addChild('LINE_ID', 1);
			$phone_line->addChild('EP_ALIAS', $data['ep_alias']);
			$phone_line->addChild('EP_PIN', $data['ep_pin']);
			if ( strlen($data['ext']) ) {
				$number = $phone_line->addChild('NUMBER', $data['ext']);
				$number->addAttribute('type', 'EXT');
				$number->addAttribute('main', 'true');
				if ($data['voicemail']) {
					$number->addAttribute('vmOfferingId', $data['voicemail']);
					$number->addAttribute('mailbox', $data['ext']);
				}
				if ( strlen($data['did']) ) {
					$number = $phone_line->addChild('NUMBER', $data['did']);
					$number->addAttribute('type', 'DID');
					$number->addAttribute('main', 'false');
					if ($data['voicemail']) {
						$number->addAttribute('vmOfferingId', $data['voicemail']);
						$number->addAttribute('mailbox', $data['ext']);
					}
				}
			}
			elseif ( strlen($data['did']) ) {
				$number = $phone_line->addChild('NUMBER', $data['did']);
				$number->addAttribute('type', 'DID');
				$number->addAttribute('main', 'true');
				if ($data['voicemail']) {
					$number->addAttribute('vmOfferingId', $data['voicemail']);
					$number->addAttribute('mailbox', $data['did']);
				}
			}
		}
		return $xml;
	}
}
?>