<?php
/**
*
* common [English]
*
* @author David Lewis
* @package reseller modules
* @version $Id: features.php,v 1.24 2010/02/25 16:08:21 lsmith Exp $
* @copyright (c) 2007 Stratus Technologies
* @license Stratus Technologies
*
*/

/**
* reseller_agent_maintenance
* Reseller Agent Maintenance
* @package owner
*/
class features
{
	public $u_action;

	function main($id, $mode)
	{
		global $soap, $template, $user, $read_only, $config;

		$sub_id		= request_var('sub_id', '');
		$ajax		= request_var('ajax_layer', '');

		$subscribe	= request_var('subscribe', '');
		$type		= request_var('type', '');

		$phone_id	= request_var('phone_id', 0);
		$line_id	= request_var('line_id', '');
		$number_id	= request_var('number_id', '');
		$feature_offering_id = request_var('feature_offering_id', 0);

		if ( isset($user->data['is_pbx']) && $user->data['is_pbx'] )
		{
			$cust_id = $user->data['cust_id'];
			$acct_id = $user->data['acct_id'];
			
			$this->u_action .= '&amp;sub_id=' . $sub_id;
			
			if (isset($config['sip_trunk']) && $config['sip_trunk']) {
				$page = array(
					'SIP_TRUNK_CENTREX_USERS'	=> str_replace('mode=' . $mode, 'mode=centrex_users', $this->u_action),
				
				);
			}
			else {
				$page = array(
					'CENTREX_USERS'	=> str_replace('mode=' . $mode, 'mode=centrex_users', $this->u_action),
				);
			}
		}
		else 
		{
			$fee_id		= request_var('fee_id', 0);
			$acct_id	= request_var('acct_id', 0);
			$cust_id	= request_var('cust_id', '');
			$act_service_type = request_var('service_type', -1);
			
			$this->u_action .= '&amp;sub_id=' . $sub_id . '&amp;cust_id=' . $cust_id . '&amp;acct_id=' . $acct_id.'&amp;service_type='.$act_service_type;
			
			$page = array(
			'AGENTS'		=> str_replace('mode=' . $mode, 'mode=maintain', $this->u_action),
			'SUBSCRIBERS'	=> str_replace('mode=' . $mode, 'mode=maintain', $this->u_action) . '&amp;action=details&amp;acct_id=' . $acct_id . '&amp;cust_id=' . $cust_id . '&amp;fee_id=' . $fee_id.'&amp;service_type='.$act_service_type,
			);
		}
		breadcrumbs($page);

		

		/**
		 * Display all subscribed features here
		 */
		switch ($subscribe)
		{

			case 'subscribe':
				// subscribe to an available feature
				$xml_ary = array(
					$sub_id,
					$feature_offering_id,
					$this->feature_name($feature_offering_id),
					$phone_id,
					$line_id,
					$number_id,
				);
				$status = 'billing3';
				$soap->send(BEGIN_SERVICE, $xml_ary, $status, false, false, true);
				confirmation_box($status, 'SUBSCRIBED_FEATURE');
			break;

			case 'unsubscribe':
				// subscribe to an available feature
				$status = 'billing3';
				$soap->send(END_SERVICE, request_var('subscribed_feature_id', 0), $status, false, false, true);
				confirmation_box($status, 'UNSUBSCRIBED_FEATURE');
			break;

			default:
				$status = 'billing3';
				$result = $soap->send(GET_SERVICES, $sub_id, $status);

				$count = 0;
				$number_ary = $line_ary = $phone_ary = array();

				foreach ($result as $row)
				{
//					if (!empty($row['end_date']))
//					{
//						continue;
//					}
					$template->assign_block_vars('subscribed_features', array(
						'END_DATE'				=> $row['end_date'],
						'FEATURE_DESCRIPTION'	=> $row['feature_description'],
						'FEATURE_ID'			=> $row['feature_id'],
						'FEATURE_NAME'			=> $row['feature_name'],
						'FEATURE_OFFERING_ID'	=> $row['feature_offering_id'],
						'FEATURE_TYPE_ID'		=> $row['feature_type_id'],
						'LINE_ID'				=> $row['line_id'],
						'MODIFIED_BY'			=> $row['modified_by'],
						'MODIFIED_DATE'			=> $row['modified_date'],
						'PHONE_ID'				=> $row['phone_id'],
						'PPR_USER_ID'			=> $row['ppr_user_id'],
						'START_DATE'			=> $row['start_date'],
						'SUBSCRIBED_FEATURE_ID'	=> $row['subscribed_feature_id'],
						'VIRTUAL_NUMBER'		=> $row['virtual_number'],

						'S_COUNT'				=> ++$count,

						'U_SUBSCRIBED_SERVICE'	=> $this->u_action, // will be a direct link that opens up the phones, lines and numbers to the exact location
					));

					if (!empty($row['virtual_number']) && empty($row['end_date']))
					{
						if (isset($number_ary[$row['phone_id']][$row['line_id']][$row['virtual_number']]))
						{
							$number_ary[$row['phone_id']][$row['line_id']][$row['virtual_number']]++;
						}
						else
						{
							$number_ary[$row['phone_id']][$row['line_id']][$row['virtual_number']] = 1;
						}
					}
					else if (!empty($row['line_id']))
					{
						if (isset($line_ary[$row['phone_id']][$row['line_id']]))
						{
							$line_ary[$row['phone_id']][$row['line_id']]++;
						}
						else
						{
							$line_ary[$row['phone_id']][$row['line_id']] = 1;
						}
					}
					else if (!empty($row['phone_id']) || $row['phone_id'] == '0')
					{
						if (isset($phone_ary[$row['phone_id']]))
						{
							$phone_ary[$row['phone_id']]++;
						}
						else
						{
							$phone_ary[$row['phone_id']] = 1;
						}
					}
				}

				/**
				 * now display phones, lines and numbers just like on the line maintenance screen with the button being "subscribe feature"
				 */
				// display the phones for this subscriber
				$status = 'billing3';
				$result = $soap->send(GET_SUBSCRIBER_DETAILS_ID, $sub_id, $status, false, true);

				if ( !$result->error )
				{
					$result = $result->data->row->phone;
					$phone_count = $line_count = 0;
	
					foreach ($result as $row)
					{
						$current_phone = (string) $row->PHONE_ID;
						$template->assign_block_vars('phones', array(
							'PHONE_ID'		=> $row->PHONE_ID,
							'MAC_ADDR'		=> $row->MAC_ADDR,
							'PHONE_TYPE'	=> $row->PHONE_TYPE,
							'SUBSCRIBED_ID'	=> (isset($phone_ary[$current_phone])) ? $phone_ary[$current_phone] : '',
	
							'S_PHONE_COUNT'	=> ++$phone_count,
	
							'U_SUBSCRIBE_FEATURE'	=> $this->u_action . '&amp;phone_id=' . $row->PHONE_ID . '&amp;subscribe=list&amp;type=phone',
						));
	
						$template->assign_block_vars('lines', array(
							'S_FIRST_BLOCK'	=> true,
							'S_PHONE_COUNT'	=> $phone_count,
						));
	
						foreach ($row->phoneline as $line)
						{
							$current_line = (string) $line->LINE_ID;
							$template->assign_block_vars('lines', array(
								'LINE_ID'		=> $line->LINE_ID,
								'EP_ALIAS'		=> $line->EP_ALIAS,
								'EP_PIN'		=> $line->EP_PIN,
								'SUBSCRIBED_ID'	=> (isset($line_ary[$current_phone][$current_line])) ? $line_ary[$current_phone][$current_line] : '',
	
								'S_PHONE_COUNT'	=> $phone_count,
								'S_LINE_COUNT'	=> ++$line_count,
	
								'U_SUBSCRIBE_FEATURE'	=> $this->u_action . '&amp;phone_id=' . $row->PHONE_ID . '&amp;line_id=' . $line->LINE_ID . '&amp;subscribe=list&amp;type=line',
							));
	
							$template->assign_block_vars('numbers', array(
								'S_FIRST_BLOCK'	=> true,
								'S_LINE_COUNT'	=> $line_count,
							));
	
							foreach ($line->NUMBER as $number)
							{
								$current_number = (string) $number;
	
								$template->assign_block_vars('numbers', array(
									'TYPE'			=> $number['type'],
									'MAILBOX'		=> $number['mailbox'],
									'NUMBER'		=> $number,
									'SUBSCRIBED_ID'	=> (isset($number_ary[$current_phone][$current_line][$current_number])) ? $number_ary[$current_phone][$current_line][$current_number] : '',
	
									'S_LINE_COUNT'	=> $line_count,
	
									'U_SUBSCRIBE_FEATURE'	=> $this->u_action . '&amp;phone_id=' . $row->PHONE_ID . '&amp;line_id=' . $line->LINE_ID . '&amp;number_id=' . $number . '&amp;subscribe=list&amp;type=number',
	
								));
							}
	
							$template->assign_block_vars('numbers', array(
								'S_LAST_BLOCK'	=> true,
								'S_LINE_COUNT'	=> $line_count,
							));
						}
	
						$template->assign_block_vars('lines', array(
							'S_LAST_BLOCK'	=> true,
							'S_PHONE_COUNT'	=> $phone_count,
						));
					}
					$template->assign_vars(array(
						'TOTAL_PHONES'	=> $phone_count,
						'TOTAL_LINES'	=> $line_count,
					));
				}
			break;
		}
		if ($ajax ) {
			$this->feature_list ($type, $cust_id, $acct_id, $number_id, $line_id, $phone_id, $sub_id);
		}
		$template->assign_var('U_READ_ONLY', $read_only);
		/**
		 * @todo create a function to begin service for a phone, line, number or did
		 */

		/**
		 * @todo create a function to end service for a phone, line, number or did
		 */
	}

	function feature_list ($type, $cust_id, $acct_id, $number_id, $line_id, $phone_id, $sub_id) {
		global $soap, $template;
		//setup the u_action for subscribing
		$subscribe_url = $this->u_action;
		switch ($type)
		{
			case 'number':
				$subscribe_url .= '&amp;number_id=' . $number_id;
			case 'line':
				$subscribe_url .= '&amp;line_id=' . $line_id;
			case 'phone':
				$subscribe_url .= '&amp;phone_id=' . $phone_id;
			break;
		}

		// in this case, we list the available features for this subscriber/phone/line/number
		$feature_ary = $subscribed_ary = array();
		$status = 'billing3';
		$result = $soap->send(GET_FEATURE_OFFERINGS, array($cust_id, $acct_id), $status);

		foreach ($result as $row)
		{
			if ( $row['feature_offering_level'] == FO_LEVEL_DID_EXT )
			{
				$feature_ary[$row['feature_offering_id']] = array(
					'FEATURE_NAME'			=> $row['feature_name'],
					'FEATURE_OFFERING_ID'	=> $row['feature_offering_id'],
					'FEATURE_ID'			=> $row['feature_id'],
					'OFFERED_TO_CUST_ID'	=> $row['offered_to_cust_id'],
					'OFFERED_TO_ACCT_ID'	=> $row['offered_to_acct_id'],
					'AMOUNT'				=> amount_convert_to_display($row['amount']),
					'TAXABLE'				=> $row['taxable'],
					'RECURRING'				=> $row['recurring'],
					'PRORATE'				=> $row['prorate'],
					'MODIFIED_BY'			=> $row['modified_by'],
					'MODIFIED_DATE'			=> $row['modified_date'],

					'U_SUBSCRIBE'			=> $subscribe_url . '&amp;subscribe=subscribe&amp;feature_offering_id=' . $row['feature_offering_id'] . '&amp;number_id=' . $number_id ,
					'U_UNSUBSCRIBE'			=> '',
				);
			}
		}

		$status = 'billing3';
		$result = $soap->send(GET_SERVICES, $sub_id, $status);

		foreach ($result as $row)
		{
			if ($row['end_date'])
			{
				continue;
			}

			// make sure this isn't subscribed to this subscriber/phone/line/number already
			switch ($type)
			{
				default:
					if ($row['virtual_number'] == $number_id)
					{
						if (isset($feature_ary[$row['feature_offering_id']]))
						{
							$subscribed_ary[$row['feature_offering_id']] = $feature_ary[$row['feature_offering_id']];
							$subscribed_ary[$row['feature_offering_id']]['U_UNSUBSCRIBE'] = $this->u_action . '&amp;subscribe=unsubscribe&amp;subscribed_feature_id=' . $row['subscribed_feature_id'] . '&amp;number_id=' . $number_id ;
							unset($feature_ary[$row['feature_offering_id']]);
						}
						continue;
					}
				break;
				case 'line':
					if ($row['line_id'] == $line_id && $row['phone_id'] == $phone_id && empty($row['virtual_number']))
					{
						if (isset($feature_ary[$row['feature_offering_id']]))
						{
							$subscribed_ary[$row['feature_offering_id']] = $feature_ary[$row['feature_offering_id']];
							$subscribed_ary[$row['feature_offering_id']]['U_UNSUBSCRIBE'] = $this->u_action . '&amp;subscribe=unsubscribe&amp;subscribed_feature_id=' . $row['subscribed_feature_id'] . '&amp;number_id=' . $number_id ;
							unset($feature_ary[$row['feature_offering_id']]);
						}
						continue;
					}
				break;
				case 'phone':
					if ($row['phone_id'] == (string) $phone_id && empty($row['line_id']) && empty($row['virtual_number']))
					{
						if (isset($feature_ary[$row['feature_offering_id']]))
						{
							$subscribed_ary[$row['feature_offering_id']] = $feature_ary[$row['feature_offering_id']];
							$subscribed_ary[$row['feature_offering_id']]['U_UNSUBSCRIBE'] = $this->u_action . '&amp;subscribe=unsubscribe&amp;subscribed_feature_id=' . $row['subscribed_feature_id'] . '&amp;number_id=' . $number_id ;
							unset($feature_ary[$row['feature_offering_id']]);
						}
						continue;
					}
				break;
						//add this one later
//						case 'subscriber':
//							if (!$row['phone_id'] && !$row['line_id'] && !$row['virtual_number'])
//							{
//								continue;
//							}
//						break;
					}
				}

		foreach ($feature_ary as $array)
		{
			$template->assign_block_vars('features', $array);
		}

		$cnt = 0;
		foreach ($subscribed_ary as $array)
		{
			$template->assign_block_vars('subscribed', $array);
			$cnt++;
		}

//trigger_error(print_r('count = '. sizeof($subscribed_ary)));
//trigger_error(print_r($subscribed_ary));
		$template->assign_vars(array(
			'S_SUBSCRIBER_FEATURES_LIST'	=> true,
			'JQUERY_AJAX_ADD_EDIT'			=> true,
//			'S_SUBSCRIBBED_COUNT'			=> sizeof($subscribed_ary),
			'S_SUBSCRIBBED_COUNT'			=> $cnt,
			'S_SUBSCRIBBED_NUYMBER'			=> $number_id,
			'U_SUBSCRIBER_FEATURES_LIST'	=> $subscribe_url . '&amp;subscribe=list&amp;type=' . $type,
		));
		
	}
	
	function feature_name($feature_id)
	{
		global $soap;

		$cust_id = request_var('cust_id', '');
		$acct_id = request_var('acct_id', 0);

		$status = 'billing3';
		$result = $soap->send(GET_FEATURE_OFFERINGS, array($cust_id, $acct_id), $status);

		foreach ($result as $row)
		{
			if ($feature_id == $row['feature_offering_id'])
			{
				return $row['feature_name'];
			}
		}
		return false;
	}
}

?>