<?php
/**
*
* common [English]
*
* @author Lorence Smith
* @package reseller modules
* @version $Id: voicemail_admin.php,v 1.34 2011/05/18 10:31:33 hydesun Exp $
* @copyright (c) 2007 Stratus Technologies
* @license Stratus Technologies
*
*/

/**
* @package reseller
*/
class voicemail_admin
{
	public $u_action;

	function main($id, $mode)
	{
		global $soap, $template, $user, $config;

		$action = request_var('action', '');
		$sub_id = request_var('sub_id', '');
		
		if (isset($user->data['is_pbx']) && $user->data['is_pbx'] )
		{
			$cust_id = $user->data['cust_id'];
			$acct_id = $user->data['acct_id'];
			
			if (isset($config['sip_trunk']) && $config['sip_trunk']) {
				$page = array(
					'SIP_TRUNK_CENTREX_USERS'	=> str_replace('mode=' . $mode, 'mode=centrex_users', $this->u_action),
				
				);
			}
			else {
				$page = array(
					'CENTREX_USERS'	=> str_replace('mode=' . $mode, 'mode=centrex_users', $this->u_action),
				);
			}
		}
		else 
		{
			$acct_id = request_var('acct_id', 0);
			$cust_id = request_var('cust_id', 0);
			$fee_id = request_var('fee_id', 0);
			$act_service_type = request_var('service_type', -1);
			
			$this->u_action .= '&amp;sub_id=' . $sub_id . '&amp;cust_id=' . $cust_id . '&amp;acct_id=' . $acct_id . '&amp;fee_id=' . $fee_id.'&amp;service_type='.$act_service_type;
			$page = array(
				'AGENTS'			=> str_replace(array('i=' . $id, 'mode=' . $mode), array('i=subscriber', 'mode=maintain'), $this->u_action),
				'SUBSCRIBERS'		=> str_replace(array('i=' . $id, 'mode=' . $mode), array('i=subscriber', 'mode=maintain'), $this->u_action) . '&amp;action=details'.'&amp;service_type='.$act_service_type,
			);
		}
		breadcrumbs($page);
		
		$xml = new SimpleXMLElement('<row></row>');
		$xml->addChild('CUST_ID', $cust_id);
		$xml->addChild('ACCT_ID', $acct_id);
		$xml->addChild('FEATURE_TYPE_ID', 4);
		$xml->addChild('filter', "CUST_ID|=|".$cust_id
								."|ACCT_ID|=|".$acct_id
								."|FEATURE_TYPE_ID|=|4"
								);
		$status = 'billing3';
		$result = $soap->send(GET_FEATURE_OFFERINGS_XML, $xml->asXML(), $status, false, true);
		$result = $result->xpath('//row');
		$name_arr = array();
		foreach ($result as $row) {
			$name_arr[(string)$row->FEATURE_TYPE_ID] = $row->FEATURE_NAME;
		}
		
		//add update and delete actions happen first
		$soap_user_id = get_soap_user_id();
		switch ($action)
		{
			case 'forward_mailbox':
				$mailbox 	= request_var('mailbox', 'NO_MAILBOX');
				$toMailbox = request_var('to_mailbox', 'NO_WHERE');

				if ( $toMailbox == 'NO_WHERE' )
				{
					$error_ary = array(
						'error'			=> 1,
						'error_message'	=> $user->lang['NO_MAILBOX_SELECTED'],
						'status'		=> '',
					);
					confirmation_box($error_ary, $name_arr[4] . ' ' . 'NO_MAILBOX_SELECTED');
				}
				else
				{
					$this->delete_voicemail_account($sub_id, $mailbox);
	
					// unForward mailbox
					$status = 'voicemail';
					$soap->send(UNFORWARD_VOICEMAIL_BOX, $mailbox, $status, false, false, true);
	
					// Set Entice Sub_Feature
					$status = 'entice';
					$soap->send(CHANGE_FEATURE_VOICEMAIL, array($mailbox, 1, $soap_user_id, $cust_id), $status);
					
					// Forward mailbox
					$xml_ary = array(
						$mailbox,
						$toMailbox,
						$cust_id,
					);
	
					$status = 'voicemail';
					$soap->send(FORWARD_VOICEMAIL_BOX, $xml_ary, $status, false, false, true);
					confirmation_box($status, $name_arr[4] . ' ' . 'MAILBOX_FORWARDED');
				}
			break;

			case 'enable_mailbox':
				$mailbox 	= request_var('mailbox', '');

				// Set Entice Sub_Feature
				$status = 'entice';
				$soap->send(CHANGE_FEATURE_VOICEMAIL, array($mailbox, 1, $soap_user_id, $cust_id), $status);
				confirmation_box($status, $name_arr[4] . ' ' . 'MAILBOX_ENABLED');
			break;

			case 'add_mailbox':
				$mailbox 	= request_var('mailbox', '');
				$name 		= request_var('name', '');
				$email		= request_var('email', '');
				$pager		= request_var('pager', '');
				$password	= request_var('password', 'NOT_EQUAL');
				$password2	= request_var('password2', 'TO_ME');

				// Set Entice Sub_Feature
				$status = 'entice';
				$soap->send(CHANGE_FEATURE_VOICEMAIL, array($mailbox, 1, $soap_user_id, $cust_id), $status);
				
				// unForward mailbox
				$status = 'voicemail';
				$soap->send(UNFORWARD_VOICEMAIL_BOX, $mailbox, $status, false, false, true);

				if ($password == $password2 && $name)
				{
					$xml_ary = array(
						$name,
						$mailbox,
						$pager,
						$email,
						$password,
						$sub_id,
					);

					$status = 'voicemail';
					$result = $soap->send(ADD_VOICE_MAIL_USER, $xml_ary, $status);
					confirmation_box($status, $result);
				}
				else
				{
					$error_lang = 'MISSING_FIELD_ERROR';
					if ($password != $password2)
					{
						$error_lang = 'PASS_FAIL';
					}

					$status = array (
						'status'		=> false,
						'error_message' => $user->lang[$error_lang],
					);
					confirmation_box($status, $user->lang[$error_lang]);
				}
			break;
			
			case 'edit_mailbox':
				$mailbox 	= request_var('mailbox', '');
				$name 		= request_var('name', '');
				$email		= request_var('email', '');
				$pager		= request_var('pager', '');
				$password	= request_var('password', 'NOT_EQUAL');
				$password2	= request_var('password2', 'TO_ME');

				if ($password == $password2)
				{
					if ( strlen($password) > 10 )
					{
						$password = substr($password, 0, 10);
						confirmation_box(array('status'=>'successful'), 'TRUNCATED_PASSWORD');
					}
					$xml_ary = array(
						$name,
						$mailbox,
						$pager,
						$email,
						$password,
						$sub_id,
					);

					$status = 'voicemail';
					$result = $soap->send(UPDATE_VOICE_MAIL_USER, $xml_ary, $status);
					confirmation_box($status, 'USER_UPDATED');
				}
				else
				{
					$error_lang = 'MISSING_FIELD_ERROR';
					if ($password != $password2)
					{
						$error_lang = 'PASS_FAIL';
					}

					$status = array (
						'status'		=> false,
						'error_message' => $user->lang[$error_lang],
					);
					confirmation_box($status, $user->lang[$error_lang]);
				}
			break;
			
			case 'disable_mailbox':
				$mailbox = request_var('mailbox', 'NO_MAILBOX' . ' ' . $name_arr[4] );
				
				$status = 'entice';
				$soap->send(CHANGE_FEATURE_VOICEMAIL, array($mailbox, 2, $soap_user_id, $cust_id), $status);
				confirmation_box($status, 'MAILBOX_DISABLED');
			break;

			case 'delete_mailbox':
				$mailbox = request_var('mailbox', 'NO_MAILBOX' . ' ' . $name_arr[4] );
				
				$status = 'entice';
				$soap->send(CHANGE_FEATURE_VOICEMAIL, array($mailbox, 2, $soap_user_id, $cust_id), $status);
				
				$data = $this->delete_voicemail_account($sub_id, $mailbox);
				confirmation_box($data['STATUS'], $data['RESULT']);
			break;
			
			case 'msg_delete':
				if (confirm_box(true))
				{
					$xml_ary = array(
						$sub_id,
						request_var('mailbox', 'NO_MAILBOX' . ' ' . $name_arr[4] ),
						request_var('mn', 'NO_MESSAGE_NUM'),
						request_var('msg_folder', 'NO_MESSAGE_FOLDER'),
					);
					$status = 'voicemail';
					$result = $soap->send(DELETE_VOICE_MAIL_MESSAGE, $xml_ary, $status);

					confirmation_box($status, $result);
				}

				$xml_ary = array(
					$sub_id,
					request_var('mailbox', 'NO_MAILBOX' . ' ' . $name_arr[4] ),
					request_var('mn', 'NO_MESSAGE_NUM'),
					request_var('msg_folder', 'NO_MESSAGE_FOLDER'),
				);
				$status = 'voicemail';
				$result = $soap->send(DELETE_VOICE_MAIL_MESSAGE, $xml_ary, $status);

				confirmation_box($status, $result);
			break;
		}

		$all_messages = array();
		$status = 'voicemail';
		$result = $soap->send(GET_VOICEMAIL_BOX_BY_SUBSCRIBER, $sub_id, $status, false, true);
		if ( ! $result->error )
		{
			$service_status = 'billing3';
			$service_result = $soap->send(GET_ACTIVE_SERVICES, $sub_id, $service_status, false, true);
	
			if (sizeof($result))
			{
				foreach ($result->data->row->mailbox as $mailbox)
				{
					$voicemail_result = $service_result->xpath('//row[FEATURE_TYPE_ID = "4" and VIRTUAL_NUMBER = "'.$mailbox->NUMBER.'"]');
					if (! sizeof($voicemail_result) )
					{
						continue;
					}
					
					$forward_select = '<select name="to_mailbox">';
					foreach ($result->data->row->mailbox as $frw_select)
					{
						if (strtolower($frw_select->STATUS) == 'enabled' && $frw_select->NUMBER != $mailbox->NUMBER)
						{
							$forward_select .= '<option value="' .  $frw_select->NUMBER . '">' . $frw_select->MAILBOX . '</option>';
						}
					}
					$forward_select .= '</select>';
					
					$stat_lang = $stat_s = '';
					if ($mailbox->STATUS == 'FORWARDED')
					{
						$stat_lang = $user->lang["$mailbox->STATUS"];
						$stat_s = strtolower($mailbox->STATUS);
					}
					else
					{
						$status = 'entice';
						$feat_vm = $soap->send(GET_FEATURE_VOICEMAIL, array($mailbox->NUMBER, $cust_id), $status, false, true);
						if (!$feat_vm->error && $feat_vm->data->row->STATUS != 0)
						{
							$feat_vm = $feat_vm->data->row;
							$stat_ary = array(
								1	=> 'ENABLED',
								2	=> 'DISABLED',
							);
							
							$stat_lang = $user->lang[$stat_ary["$feat_vm->STATUS"]];
							$stat_s = strtolower($stat_ary["$feat_vm->STATUS"]);
						}
					}
					
					$template->assign_block_vars('mailbox', array(
						'PHONE_NUM'		=> $mailbox->NUMBER,
						'MAIL_BOX'		=> isset($mailbox->MAILBOX) ? $mailbox->MAILBOX : '',
						'STATUS'		=> $stat_lang,
						'S_STATUS'		=> $stat_s,
						'S_FWD_SELECT'	=> (strstr($forward_select, 'option'))? $forward_select : $user->lang['NO_AVAIL_MAILBOX'],
						'FWD_NUMBER'	=> isset($mailbox->TRANSLATED_NUMBER) ? $mailbox->TRANSLATED_NUMBER : $user->lang['FORWARD_TO'],
						
						'EDIT_VARS'		=> 'mailbox='.$mailbox->MAILBOX.'&amp;name='.$mailbox->FULLNAME.'&amp;email='.$mailbox->EMAIL.'&amp;password='.$mailbox->PASSWORD.'&amp;password2='.$mailbox->PASSWORD,
					
						'U_FORWARD_BOX'	=> $this->u_action . '&amp;sub_id=' . $sub_id . '&amp;action=forward_mailbox&amp;mailbox=' . $mailbox->MAILBOX . '&amp;cust_id=' . $cust_id . '&amp;acct_id=' . $acct_id,
						'U_DELETE_BOX'	=> $this->u_action . '&amp;sub_id=' . $sub_id . '&amp;action=delete_mailbox&amp;mailbox=' . $mailbox->MAILBOX . '&amp;cust_id=' . $cust_id . '&amp;acct_id=' . $acct_id,						
						'U_DISABLE_BOX'	=> $this->u_action . '&amp;sub_id=' . $sub_id . '&amp;action=disable_mailbox&amp;mailbox=' . $mailbox->MAILBOX . '&amp;cust_id=' . $cust_id . '&amp;acct_id=' . $acct_id,
						'U_ENABLE_BOX'	=> $this->u_action . '&amp;sub_id=' . $sub_id . '&amp;action=enable_mailbox&amp;mailbox=' . $mailbox->MAILBOX . '&amp;cust_id=' . $cust_id . '&amp;acct_id=' . $acct_id,
	
					));
	
					$xml_ary = array(
						$sub_id,
						$mailbox->MAILBOX,
					);
	
					$vmstatus = 'voicemail';
					$vmreslt = $soap->send(GET_VOICE_MESSAGES, $xml_ary, $vmstatus);
	
					if (sizeof($vmreslt))
					{
						foreach ($vmreslt as &$msg)
						{
							$msg['phone_num'] = (string)$mailbox->NUMBER;
						}
						$all_messages = array_merge($all_messages, $vmreslt);
					}
				}
				if (sizeof($all_messages))
				{
					//Should work but can't figure out why not.
					
//					function compare_time($left, $right)
//					{
//						if ( $left['origtime'] == $right['origtime'] )	{ return 0; }
//						else if ( $left['origtime'] < $right['origtime'] )	{ return -1; }
//						else { return 1; }
//					}
//					uasort($all_messages, 'compare_time');
//					foreach ($all_messages as $msg)
//					{
//						$template->assign_block_vars('messages', array(
//							'PHONE_NUM'		=> $msg['phone_num'],
//							'MSGNUM'		=> $msg['msgnum'],
//							'MAILBOXUSER'	=> $msg['mailboxuser'],
//							'MSG_FOLDER'	=> $msg['msg_folder'],
//							'CALLER_ID'		=> htmlspecialchars($msg['callerid']),
//							'ORIG_TIME'		=> date(DB_DATE_FORMAT, $msg['origtime']),
//							'DURATION'		=> $msg['duration'],
//							'MSG_STATUS'	=> (strtoupper($msg['msg_folder']) == 'INBOX')? $user->lang['NEW'] : $user->lang['PLAYED'],
//							'MSG_URL'		=> htmlspecialchars($msg['msg_url']),
//							'U_MSG_DELETE'	=> $this->u_action . '&amp;sub_id=' . $sub_id . '&amp;action=msg_delete&amp;mn=' . $msg['msgnum'] . '&amp;msg_folder=' . $msg['msg_folder'] . '&amp;mailbox=' . $msg['mailboxuser'] . '&amp;cust_id=' . $cust_id . '&amp;acct_id=' . $acct_id,
//						));
//					}
					
					$msg_order = array();
					foreach ($all_messages as $num => $message) {
						$msg_order[$message['origtime']] = $num;
					}
					ksort($msg_order);
					foreach ($msg_order as $msg_num)
					{
						$template->assign_block_vars('messages', array(
							'PHONE_NUM'		=> $all_messages[$msg_num]['phone_num'],
							'MSGNUM'		=> $all_messages[$msg_num]['msgnum'],
							'MAILBOXUSER'	=> $all_messages[$msg_num]['mailboxuser'],
							'MSG_FOLDER'	=> $all_messages[$msg_num]['msg_folder'],
							'CALLER_ID'		=> htmlspecialchars($all_messages[$msg_num]['callerid']),
							'ORIG_TIME'		=> date(DISPLAY_DATE_FORMAT, $all_messages[$msg_num]['adjusted_origtime']),
							'DURATION'		=> $all_messages[$msg_num]['duration'],
							'MSG_STATUS'	=> (strtoupper($all_messages[$msg_num]['msg_folder']) == 'INBOX')? $user->lang['NEW'] : $user->lang['PLAYED'],
							'MSG_URL'		=> htmlspecialchars($all_messages[$msg_num]['msg_url']),
							'U_MSG_DELETE'	=> $this->u_action . '&amp;sub_id=' . $sub_id . '&amp;action=msg_delete&amp;mn=' . $all_messages[$msg_num]['msgnum'] . '&amp;msg_folder=' . $all_messages[$msg_num]['msg_folder'] . '&amp;mailbox=' . $all_messages[$msg_num]['mailboxuser'] . '&amp;cust_id=' . $cust_id . '&amp;acct_id=' . $acct_id,
						));
					}
				}
			}
		}
		
		$status = 'billing3';
		$result = $soap->send(GET_SUB_CONTACTS, array($sub_id), $status, false, true);
		$add_email = '';
		$add_name = '';
		
		foreach ($result->xpath("//FIRSTNAME") as $key => $val)
		{
			if ( $val != '' )
			{
				$last = $result->xpath("//LASTNAME");
				$add_name = $val . ' ' . $last[$key];
				break;
			}
		}
		
		foreach ($result->xpath("//EMAIL") as $key => $val)
		{
			if ( $val != '' )
			{
				$add_email = $val;
				break;
			}
		}
		
		$template->assign_vars(array(
			'VOICEMAIL_NAME' => $name_arr[4],
			'SUB_NAME'		=> $add_name,
			'SUB_EMAIL'		=> $add_email,
		));
	}

	private function delete_voicemail_account($sub_id, $mailbox)
	{
		global $soap;

		$status = 'voicemail';
		$soap->send(REMOVE_FORWARDED_MAILBOXES, $mailbox, $status, false, false, true);

		// Disable voicemail account
		$xml_ary = array(
			$sub_id,
			$mailbox
		);

		$status = 'voicemail';
		$result = $soap->send(DELETE_VOICE_MAIL_USER, $xml_ary, $status);

		return array(
			'STATUS'	=> $status,
			'RESULT'	=> $result
		);
	}
}
?>
